import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class puzzleEntry extends Frame implements ActionListener, WindowListener
{
	private TextField value = new TextField(10);
	private String names="";
	private int score=0;

	private PrintWriter outgoingFile;
	private BufferedReader inFile;

	public static void main(String[] args)
	{
		puzzleEntry f = new puzzleEntry(20);
		f.setSize(300,300);
		f.setVisible(true);
	}
	public puzzleEntry(int sc)
	{
		setLayout(new FlowLayout());
		value.addActionListener(this);
		add(value);

		score=sc;
		this.addWindowListener(this);
	}
	public void paint(Graphics g)
	{
		if(obtain())
		{
			g.drawString("Congratulations! You are",50,100);
			g.drawString("on the high scores! ",50,120);

			g.drawString(names,0,0);
		}
		else
		{
			g.drawString("Congratulations, but you",50,100);
			g.drawString("didn't qualify for the high scores.",50,120);
			remove(value);
		}
	}
	public void actionPerformed(ActionEvent e)
	{
		this.setVisible(false);
		//enter values into high scores
		try
		{
			inFile  = new BufferedReader(new FileReader("highScores.txt"));
			String line;
			boolean skipNext=false;
			boolean written=false;
			int i=1;
			//first line is score, second is name...etc.,
			names="";
			while((line=inFile.readLine())!=null)
			{
				if(i%2==1)	//if score is read in
				{
					if(score<Integer.parseInt(line) && !written)
					{
						names+=score+"\n";
						names+=value.getText()+"\n";
						skipNext=true;
						written=true;
					}
					else
					{
						names+=line+"\n";
					}
				}
				else
				{
					if(!skipNext)
					{
						names+=line;
						names+="\n";
					}else skipNext=false;
				}
				i++;


			}
			inFile.close();

		}
		catch(IOException er){}
		try
		{
			outgoingFile = new PrintWriter(new FileWriter("highScores.txt"));

			outgoingFile.print(names);
			outgoingFile.close();
		}
		catch(IOException er){}

	}
	private boolean obtain()
	{
		boolean win=false;
		try
		{
			inFile  = new BufferedReader(new FileReader("highScores.txt"));
			String line;
			int i=1;
			//first line is score, second is name...etc.,


			while((line=inFile.readLine())!=null)
			{
				if(i%2==1)	//if score is read in
				{
					if(Integer.parseInt(line)>score)
					{
							win=true;
					}
				}
				i++;
			}
			inFile.close();

		}
		catch(IOException er){}

		return win;
	}

	public void windowClosing(WindowEvent e)
	{this.setVisible(false);
	}
	public void windowClosed(WindowEvent e){}
	public void windowOpened(WindowEvent e){}
	public void windowActivated(WindowEvent e){}
	public void windowDeactivated(WindowEvent e){}
	public void windowIconified(WindowEvent e){}
	public void windowDeiconified(WindowEvent e){}

}

